--- src/emacs.c.orig	2016-11-11 17:20:48.000000000 -0800
+++ src/emacs.c	2016-11-12 19:13:05.000000000 -0800
@@ -25,6 +25,7 @@
 #include <fcntl.h>
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 
 #include <sys/types.h>
 #include <sys/file.h>
@@ -743,6 +744,24 @@
 #ifdef DARWIN_OS
   if (!initialized)
     unexec_init_emacs_zone ();
+
+  /* Imaxima won't work properly if PATH does not contain the
+     MacPorts directory. The following code is a workaround to
+     avoid this problem. */
+  {
+    char *oldpath = getenv("PATH");
+    if (!oldpath) {oldpath = "";}
+    size_t oldpathsize = strlen(oldpath) + 1;
+    if (!strstr(oldpath, "__PREFIX__/bin")) {
+      char *newpath;
+      size_t newpathsize = oldpathsize + strlen("__PREFIX__/bin:");
+      if ((newpath = (char *)malloc(newpathsize)) != NULL) {
+        strlcpy(newpath, "__PREFIX__/bin:", newpathsize);
+        strlcat(newpath, oldpath, newpathsize);
+        setenv("PATH", newpath, 1);
+      }
+    }
+  }
 #endif
 
   init_standard_fds ();
